
#ifndef __OPCODES__
#define __OPCODES__

#define BYTEUNIT 4 // matavimo vienetas

// intermediate opkodai. dejom ant RISC, taigi CISC. hoo!
enum EIntOpcode {
        IOP_NOP,
        IOP_SAVE,       // [count]
        IOP_PUSH,       // [count]
        IOP_REFFR,      // push frame ptr
        IOP_REFTHIS,    // push this ptr
        IOP_REFSTAT,    // push static segment ptr
        IOP_REFADD,     // priesh: ..., ref, val;  po: ..., ref+val;
        IOP_DEL,        // [count] - nuima nuo steko
        IOP_GROW,       // [count] - padidina steka
        IOP_CALL,       // [count] - kuria f-ja ish vtbl kviesti
        IOP_CALLSUPER,  // [count] - kuria f-ja kviesti [vali] - kurios klases
        IOP_NATIVE,     // [count] - native slotas
        IOP_RET,
        IOP_NEW,        // [count] - typeid; grazina steke ref
        IOP_IS,         // [count] - typeid; dynamic_cast<typeid> stekas;
        IOP_DELETE,     // istrina ref (is steko ima)
        // => 1 x ptr to string
        IOP_PUSHs,      // [count==offset of string]
        // => 1 x long
		IOP_PUSHif,		// [addr==number] push 4 byte const number (i or f)
        IOP_PUSHarr,	// [count==#ofElems] push 4byteNumber array (follows command)
        // 1 x long => 1 x float
        IOP_i2f,
        // 1 x float => 1 x long
        IOP_f2i,
        // 1 x long
        IOP_JMP,        // [addr]
        IOP_JZ,
        // 2 x long|bool
        IOP_OR,         // long
        IOP_XOR,
        IOP_AND,
        IOP_SHL,
        IOP_SHR,
        IOP_MOD,
        IOP_ADDi,
        IOP_SUBi,
        IOP_MULi,
        IOP_DIVi,
        IOP_BORi,       // bool
        IOP_BANDi,
        IOP_BEi,
        IOP_BNEi,
        IOP_BLi,
        IOP_BGi,
        IOP_BLEi,
        IOP_BGEi,
        // 2 x float
        IOP_ADDf,
        IOP_SUBf,
        IOP_MULf,
        IOP_DIVf,
        IOP_BORf,       // bool
        IOP_BANDf,
        IOP_BEf,
        IOP_BNEf,
        IOP_BLf,
        IOP_BGf,
        IOP_BLEf,
        IOP_BGEf,
        // 1 x long|bool
        IOP_NEGi,
        IOP_BNOTi,
        IOP_INV,
        // 1 x long|bool [addr]
        IOP_SAVEMULi,
        IOP_SAVEDIVi,
        IOP_SAVEMOD,
        IOP_SAVEADDi,
        IOP_SAVESUBi,
        IOP_SAVESHL,
        IOP_SAVESHR,
        IOP_SAVEOR,
        IOP_SAVEXOR,
        IOP_SAVEAND,
        // 1 x float
        IOP_NEGf,
        IOP_BNOTf,
        // 1 x float [addr]
        IOP_SAVEMULf,
        IOP_SAVEDIVf,
        IOP_SAVEADDf,
        IOP_SAVESUBf,
        // inc/dec
        IOP_PREINCi, // long
        IOP_PREDECi,
        IOP_POSINCi,
        IOP_POSDECi,
        IOP_PREINCf, // float
        IOP_PREDECf,
        IOP_POSINCf,
        IOP_POSDECf,
        // advanced
        IOP_MULADDf, // 3xf: == a*b+c
        IOP_MULDIVf, // 3xf: == a*b/c
        IOP_POP,     // == iop_save + iop_del
        IOP_OFSTHIS, // == refthis; pushi vali; refadd;
        IOP_OFSFR,   // == reffr;   pushi vali; refadd;
        IOP_OFSPTR,  // == push 1;  pushi vali; refadd;
        IOP_SAVE1,   // visos analogishkos, su count==1
        IOP_PUSH1,
        IOP_POP1,
        IOP_DEL1,
        // inline pseudo f-jos
        IOP_RAND, IOP_ABS, IOP_SGN,
        IOP_MIN, IOP_MAX,
        IOP_CLAMP,
        IOP_FABS, IOP_FSGN, IOP_SIN, IOP_COS, IOP_TAN, IOP_ATAN, IOP_EXP,
        IOP_LOGE, IOP_SQRT, IOP_SQR,
        IOP_FRAND,
        IOP_FMIN, IOP_FMAX,
        IOP_FCLAMP, IOP_LINERP, IOP_COSERP,
        IOP_PRINT,
        // kitkas
        JUMPTARGET // ne opkodas, o i chia jumpas. [target rodo ish kur]
};

#endif

