
#include <iostream>
#include <cstring>
#include <stdlib.h>

#include "utils/arocfg.h"

#include "utils.h"

/** argumentai *************************************************************/

TArguments::TArguments(long c, char **v)
{
        argc = c;
        argv = new char*[c];
        long i;
        for (i = 0; i < c; i++) {
                argv[i] = new char[strlen(v[i])+1];
                strcpy(argv[i], v[i]);
        }
}
TArguments::~TArguments()
{
        long i;
        for (i = 0; i < argc; i++)
                delete[] argv[i];
        delete[] argv;
}

long TArguments::find(char **s)
{
        long i;
        for (i = argc-1; i >= 0; i--) {
                if (!strcmp(argv[i], s[0]))
                        return i;
                if (s[1] && !strcmp(argv[i], s[1]))
                        return i;
        }
        return -1;
}

char *TArguments::findS(char **s)
{
        long i = find(s) + 1;
        if (i <= 0 || i >= argc)
                return NULL;
        return argv[i];
}
long TArguments::findI(char **s)
{
        long i = find(s) + 1;
        if (i <= 0 || i >= argc)
                return 0;
        return atol(argv[i]);
}
float TArguments::findF(char **s)
{
        long i = find(s) + 1;
        if (i <= 0 || i >= argc)
                return 0;
        return atof(argv[i]);
}

/** texto eilutes **********************************************************/

struct TGetString {
        CString *str;
        char *var, *def;
};

CString strErrCreateFile;
CString strErrFindClassId;
CString strHelpUsage, strHelpKeys;
CString strHelpLine1, strHelpLine2, strHelpLine3, strHelpLine4, strHelpLine5;
CString strHelpLine6, strHelpLine7, strHelpLine8, strHelpLine9, strHelpLineA;
CString strHelpLineB, strHelpLineC, strHelpLineD;
CString strHelpDef1, strHelpDef2, strHelpVer1, strHelpVer2;
CString strCompRoot, strComp1, strComp2, strComp3, strCompOut, strCompCPP;
CString strCompHStart, strCompCPPStart, strCompEnd;
CString strErrNeedDef, strWarnStatic, strErrFindType, strErrFindFunc;
CString strErrFindSym, strErrIdentDef, strErrTypeDef, strErrStructDef;
CString strErrArgsDef, strErrStat, strErrNotClass;
CString strNameVal, strNameThis, strNameRet;
CString strDebNode, strDebEmpty, strDebCond, strDebStat, strDebInit;
CString strDebLoop, strDebObj, strDebArgs;
CString strErrNeedExpr, strErrBadTypes, strErrBadArg, strErrNeedScal;
CString strErrNeedArgs, strWarnNumPtr, strWarnPtr;
CString strErrDefined, strErrCantOver;
CString strErrOverTypes, strErrOverCount, strErrOverArg;
CString strNoteNames, strNoteCount;
CString strWarnSuperFind;

static char *miss = "missing language def";
static char *errS = "err %s";
static char *errL = "err %li";

TGetString allStrings[] = {
  { &strHelpUsage      ,"HelpUsage" ,miss},
  { &strHelpKeys       ,"HelpKeys"  ,miss},
  { &strHelpLine1      ,"HelpLine1" ,miss},
  { &strHelpLine2      ,"HelpLine2" ,miss},
  { &strHelpLine3      ,"HelpLine3" ,miss},
  { &strHelpLine4      ,"HelpLine4" ,miss},
  { &strHelpLine5      ,"HelpLine5" ,miss},
  { &strHelpLine6      ,"HelpLine6" ,miss},
  { &strHelpLine7      ,"HelpLine7" ,miss},
  { &strHelpLine8      ,"HelpLine8" ,miss},
  { &strHelpLine9      ,"HelpLine9" ,miss},
  { &strHelpLineA      ,"HelpLineA" ,miss},
  { &strHelpLineB      ,"HelpLineB" ,miss},
  { &strHelpLineC      ,"HelpLineC" ,miss},
  { &strHelpLineD      ,"HelpLineD" ,miss},
  { &strHelpDef1       ,"HelpDef1"  ,miss},
  { &strHelpDef2       ,"HelpDef2"  ,miss},
  { &strHelpVer1       ,"HelpVer1"  ,miss},
  { &strHelpVer2       ,"HelpVer2"  ,miss},
  { &strCompRoot       ,"CompRoot"  ,miss},
  { &strComp1          ,"Comp1"     ,"pass1"},
  { &strComp2          ,"Comp2"     ,"pass2"},
  { &strComp3          ,"Comp3"     ,"pass3"},
  { &strCompOut        ,"CompOut"   ,miss},
  { &strCompCPP        ,"CompCPP"   ,miss},
  { &strCompHStart     ,"CompHStart"     ,"// ???"},
  { &strCompCPPStart   ,"CompCPPStart"   ,"// ???"},
  { &strCompEnd        ,"CompEnd"        ,miss},
  { &strErrCreateFile  ,"ErrCreateFile"  ,errS},
  { &strErrFindClassId ,"ErrFindClassId" ,errL},
  { &strErrFindType    ,"ErrFindType"    ,errS},
  { &strErrFindFunc    ,"ErrFindFunc"    ,errS},
  { &strErrFindSym     ,"ErrFindSym"     ,errS},
  { &strErrIdentDef    ,"ErrIdentDef"    ,miss},
  { &strErrStructDef   ,"ErrStructDef"   ,miss},
  { &strErrTypeDef     ,"ErrTypeDef"     ,miss},
  { &strErrArgsDef     ,"ErrArgsDef"     ,miss},
  { &strErrNeedDef     ,"ErrNeedDef"     ,miss},
  { &strErrNeedExpr    ,"ErrNeedExpr"    ,errS},
  { &strErrNeedScal    ,"ErrNeedScal"    ,errS},
  { &strErrNeedArgs    ,"ErrNeedArgs"    ,"err %s %li"},
  { &strErrStat        ,"ErrStat"        ,miss},
  { &strErrNotClass    ,"ErrNotClass"    ,"err %s %s"},
  { &strErrBadTypes    ,"ErrBadTypes"    ,errS},
  { &strErrBadArg      ,"ErrBadArg"      ,errS},
  { &strErrDefined     ,"ErrDefined"     ,"err %s %s"},
  { &strErrCantOver    ,"ErrCantOver"    ,miss},
  { &strErrOverTypes   ,"ErrOverTypes"   ,miss},
  { &strErrOverCount   ,"ErrOverCount"   ,miss},
  { &strErrOverArg     ,"ErrOverArg"     ,errL},
  { &strWarnStatic     ,"WarnStatic"     ,miss},
  { &strWarnNumPtr     ,"WarnNumPtr"     ,errS},
  { &strWarnPtr        ,"WarnPtr"        ,errS},
  { &strWarnSuperFind  ,"WarnSuperFind"  ,miss},
  { &strNameVal        ,"NameVal"   , "__return_val"},
  { &strNameThis       ,"NameThis"  , "__this"},
  { &strNameRet        ,"NameRet"   , "__return_addr"},
  { &strDebNode        ,"DebNode"   ,miss},
  { &strDebEmpty       ,"DebEmpty"  ,miss},
  { &strDebCond        ,"DebCond"   ,miss},
  { &strDebStat        ,"DebStat"   ,miss},
  { &strDebInit        ,"DebInit"   ,miss},
  { &strDebLoop        ,"DebLoop"   ,miss},
  { &strDebObj         ,"DebObj"    ,miss},
  { &strDebArgs        ,"DebArgs"   ,miss},
  { &strNoteNames      ,"NoteNames" ,"(%s %s)"},
  { &strNoteCount      ,"NoteCount" ,"(%li %li)"},
  { NULL              ,NULL }
};

extern char *cfgLang;

void getStrings()
{
        TGetString *i;
        for (i = allStrings; i->str; i++) {
                char *s = cfgGetS(cfgLang, i->var, i->def);
                *i->str = s;
        }
}

