// CString eiluciu klase. maza, be featuru, uztad ne STL string monstras.
// NeARAZ, 2000 09 25

#include <cstring>
#include <iostream>

#include "CString.h"

using namespace std;

void CString::init(long nsz, const char *ns)
{
        sz = nsz;
        s = new char[sz+1];
        memcpy(s, ns, sz+1);
}

void CString::assign(long nsz, const char *ns)
{
        if (sz != nsz) {
                delete[] s;
                sz = nsz;
                s = new char[sz+1];
        }
        memcpy(s, ns, sz+1);
}

CString& CString::operator+= (const CString& ns)
{
        char *p = new char[sz + ns.sz + 1];
        memcpy(p,      s,    sz);
        memcpy(p + sz, ns.s, ns.sz + 1);
        sz += ns.sz;
        delete[] s;
        s = p;
        return *this;
}

CString& CString::operator+= (const char *ns)
{
        long l = strlen(ns);
        char *p = new char[sz + l + 1];
        memcpy(p,      s,  sz);
        memcpy(p + sz, ns, l + 1);
        sz += l;
        delete[] s;
        s = p;
        return *this;
}

CString& CString::operator+= (char ns)
{
        char *p = new char[sz + 1 + 1];
        memcpy(p, s, sz);
        p[sz] = ns;
        p[sz+1] = 0;
        sz++;
        delete[] s;
        s = p;
        return *this;
}

void CString::erase(long i)
{
        if (i <= 0) return;
        if (i > sz) i = sz;
        sz -= i;
        s[sz] = 0;
}

long CString::hashCode() const
{
        long h = 0;
        for (int i = 0; i < sz; i++) {
            long c = (long)((unsigned char)s[sz]);
            h ^= c << ((i ^ (c & 3)) & 15);
        }
        h ^= (h >> 8);
        return h & 0xFFFF;
}

CString::CString(long nsz, char *ns)
    { sz = nsz; s = ns; }

CString operator+ (const CString& a, const CString& b)
{
        long nsz = a.sz + b.sz;
        char *ns = new char[nsz+1];
        memcpy(ns,      a.s, a.sz  );
        memcpy(ns+a.sz, b.s, b.sz+1);
        CString tmp(nsz, ns);
        return tmp;
}
CString operator+ (const CString& a, const char *b)
{
        long bsz = strlen(b);
        long nsz = a.sz + bsz;
        char *ns = new char[nsz+1];
        memcpy(ns,      a.s, a.sz );
        memcpy(ns+a.sz, b,   bsz+1);
        CString tmp(nsz, ns);
        return tmp;
}
CString operator+ (const CString& a, char b)
{
        long nsz = a.sz + 1;
        char *ns = new char[nsz+1];
        memcpy(ns, a.s, a.sz);
        ns[a.sz  ] = b;
        ns[a.sz+1] = 0;
        CString tmp(nsz, ns);
        return tmp;
}

