// virtualios mashinos klase ir jos f-jos
// reikia <cstring> <fstream> <stdlib.h> <math.h> <iomanip> <iostream>

#ifndef __VMACHINE__
#define __VMACHINE__

#include "opcodes.h"

typedef void (*TVMNative)(long *); // perduoda frame-ptr

struct TClassInfo {
        void  read(FILE* f);
        long  size;
        char *name;
        long  nvtbl;
        long *vtbl;
        long  parent; // tevas
        long  foo[3]; // islyginimui
};

#define MAXREC 256 // max rekursijos gylis

class TVMachine {
        bool            ok;
        // faile
        long            ncode;          // kodo dydis baitais
        unsigned char  *code;           // kodas
        long            ncl;            // klasiu kiekis
        TClassInfo     *cli;            // klasiu info
        long            nstr;           // stringu mas. dydis
        char           *strings;        // stringai
        // begimui
        unsigned char  *stack; // stekas
        unsigned char  *data;  // static duom. segmentas
        TVMNative *native;     // native f-ju slotai
        long depth;            // dab. rekursijos gylis
        union { // stack top. rodo i ten, kur BUS dedama
                void          *ssv;
                unsigned char *ssb;
                long          *ssi;
                float         *ssf;
                void          **sspv;
                unsigned char **sspb;
                long          **sspi;
                float         **sspf;
        };
        unsigned char *ip;
        unsigned char *sbase[MAXREC];   // frame ptr prilaikymas rekursijai
        // istumiam const
        void _pushi(long  d) { ssi [0] = d; ssi++ ; };
        void _pushp(void *d) { sspv[0] = d; sspv++; };
        // daug datos
        void _push(long n) // pries: ..., ptr;        po: ..., data;
             { ssi--; memcpy(ssv, sspv[0], n*4); ssi += n; };
        void _save(long n) // pries: ..., data, ptr;  po: ..., data;
             { ssi--; memcpy(sspv[0], ssi - n, n*4); };
        void _pushArr(long n) // istumia n longu nuo IP
             { memcpy(ssv, ip, n*4); ssi += n; ip += n*4; };
        // gaunam (long*)this
        long *_getthis() { return ((long**)(sbase[depth]))[-2]; };
public:
        // filename, static data, native array, class id's, stacksize
        TVMachine(char *fn, unsigned char *dt, TVMNative *na, long sz = 65536);
        ~TVMachine();
        // interfeisui
        void  grow (long n)             { ssb += n; };
        void  del  (long n)             { ssb -= n; };
        void  push (void *p, long n)    { memcpy(ssb, p, n); ssb += n; };
        void  pushi(long d)             { ssi[0] = d; ssi++; };
        void *pop  (long n)             { ssb -= n; return ssb; };
        void  call (long, long); // kurios klases, kuria f-ja
        // RTTI
        long find(char *n) const;
        long is(long a, long b) const;
        // info
        long size(long id) const { return cli[id].size*4; };
        // virtual constructor
        void *create(long id) const;
};

inline void *TVMachine::create(long id) const
{
        long* p = new long[cli[id].size*4];
        memset(p, 0, cli[id].size*4);
        *p = id;
        return (void*)p;
}

#endif

